def is_opening(t):
    return t[1] != '/'

def corresponding(ot, ct):
    return ot[1:] == ct[2:]


def well_formed(ts):
    stack = []

    for t in ts:
        if is_opening(t):
            stack.append(t)
        else:
            if len(stack) == 0:
                return False
            ot = stack.pop()
            if not corresponding(ot, t):
                return False
    
    if len(stack) == 0:
        return True
    else:
        return False


if __name__ == '__main__':
    assert is_opening('<a>') == True
    assert is_opening('</a>') == False
    assert corresponding('<a>', '</a>') == True
    assert corresponding('<a>', '</b>') == False

    assert well_formed(['<a>', '<b>', '</b>', '<c>', '<b>', '</b>', '</c>', '<a>', '</a>', '</a>']) == True
    assert well_formed(['<a>', '<b>', '<c>', '</b>', '</c>', '<a>', '</a>', '</a>']) == False
    assert well_formed(['<a>', '<b>', '<c>', '</c>', '</b>', '</a>']) == True
    assert well_formed(['<a>', '<b>', '<c>', '</c>', '</a>']) == False
    assert well_formed(['<a>', '<b>', '<c>', '</c>', '</b>']) == False
