def inverse_polish(xs):
    if xs == []:
        return 0

    x = xs.pop()

    if type(x) == int or type(x) == float:
        return x
    
    v2 = inverse_polish(xs)
    v1 = inverse_polish(xs)

    if x == '+':
        return v1 + v2
    elif x == '-':
        return v1 - v2
    elif x == '*':
        return v1 * v2
    elif x == '/':
        return v1 / v2
    else:
        raise Exception('Unknown operator ' + str(x))
        


if __name__ == '__main__':
    assert inverse_polish([3, 4, '+']) == 7
    assert inverse_polish([2, 2, '*']) == 4 
    assert inverse_polish([3, 2, 2, '*', '+']) == 7
    assert inverse_polish([3, 4, '+', 2, 1, '+', '*', 6.0, '/']) == 3.5
